from pony import orm
from pony.orm import Database,PrimaryKey,Required,Optional,Set
#orm.set_sql_debug(True)
db = orm.Database()
#db.bind(provider='sqlite', filename=":memory:", create_db=True)
db.bind(provider='sqlite', filename="/Users/staworko/Temp/imdb.db", create_db=True)

class Movie(db.Entity):
    id = PrimaryKey(int,auto=True)
    title = Required(str)
    year = Optional(int)
    adult = Required(bool,default=False)
    runtime = Optional(int,nullable=True)
    titles = Set('Movie_Title')
    genres = Set('Movie_Genre')
    cast = Set('Star')
    crew = Set('Crew')
    ratings = Optional('Ratings')

class Movie_Title(db.Entity):
    movie = Required(Movie)
    title = Required(str)
    region = Optional(str,nullable=True)
    language = Optional(str,nullable=True)

class Movie_Genre(db.Entity):
    movie = Required(Movie)
    genre = Required(str)
    PrimaryKey(movie,genre)

class Actor(db.Entity):
    id = PrimaryKey(int,auto=True)
    name = Required(str)
    born = Optional(int)
    died = Optional(int)
    roles = Set('Star')

class Star(db.Entity):
    actor = Required(Actor)
    movie = Required(Movie)
    role = Required(str)
    PrimaryKey(actor,movie,role)

class Person(db.Entity):
    id = PrimaryKey(int,auto=True)
    name = Required(str)
    born = Optional(int)
    died = Optional(int)
    jobs = Set('Crew')

class Crew(db.Entity):
    person = Required(Person)
    movie = Required(Movie)
    job = Required(str)
    PrimaryKey(person,movie,job)

class Ratings(db.Entity):
    movie = PrimaryKey(Movie)
    average = Required(float)
    votes = Required(int)

db.generate_mapping(create_tables=True)
